<template>
  <v-app dark style="position: relative">
    <!-- <Header /> -->
    <nuxt />
    <div id="loading-full-page" v-if="loadingFullPage">
      <div class="content">
        <img :src="logo" alt="" />
        <div class="d-flex justify-center mt-2">
          <p class="mb-0" style="color: #6b7280">Loading...</p>
          <v-progress-circular
            class="ml-2 mt-1"
            indeterminate
            size="16"
            color="#6B7280"
          ></v-progress-circular>
        </div>
      </div>
    </div>
  </v-app>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import gtag from "~/utils/ads-analytic";
import { TwitterTracking, handleTwitter } from "~/assets/js/twitter";
import { onGetListCart } from "~/utils/localStorage";
import { apiErrorHandler } from "~/utils/apiHanlers";

@Component({
  components: {
    Header: () => import("@/components/Header/index.vue"),
  },
})
export default class Checkoutayout extends Vue {
  head() {
    return {
      title:
        " Checkout - " +
        `${
          this.$store.state?.setting?.settingHomePage?.homepageTitle
            ? `${this.$store.state?.setting?.settingHomePage?.homepageTitle}`
            : (this.$store.state.setting.siteInfo &&
                this.$store.state.setting.siteInfo.storeName +
                  " - " +
                  this.$store.state?.setting?.siteInfo?.productName) ||
              ""
        }`,
      link: [
        {
          rel: "icon",
          type: "image/x-icon",
          href: `${
            this.$store?.state?.setting?.siteInfo?.logo
              ? `${api}/${this.$store?.state?.setting?.siteInfo?.logo}`
              : "/logous.png"
          }`,
        },
      ],
    };
  }

  get loadingFullPage() {
    return this.$store.state.sitePage.loadingFullPage || false;
  }

  get logo() {
    const siteInfo = this.$store.state?.setting?.siteInfo;
    if (siteInfo?.logo?.imageUrl) {
      return `${api}/${siteInfo.logo.imageUrl}`;
    } else if (siteInfo?.logo) {
      return `${api}/${siteInfo.logo}`;
    }
    return "/logous.png";
  }

  noscriptAdsFacebook: any = [];

  adsTiktok: any = [];

  async mounted() {
    try {
      this.onGetListCart();
      this.loadScriptTwitter();
      this.loadScriptSnap();
      // Google
      const googlePlatformId = this.$store.state.setting.google.platformId;
      if (googlePlatformId) {
        const googlePixelIds = googlePlatformId
          .split("\n")
          .map((id: string) => id.trim())
          .filter((id: string) => id);
        if (googlePixelIds && googlePixelIds.length) {
          for (let id of googlePixelIds) {
            gtag(id);
          }
        }
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  loadScriptTwitter() {
    const twitter = this.$store.state.setting.twitter;
    if (twitter?.platformId) {
      const {
        twitterPixelId,
        pageViewId,
        contentViewId,
        addToCartId,
        checkoutInitiatedId,
        addedPaymentInfoId,
        purchaseId,
      } = twitter.platformId;
      if (
        twitterPixelId ||
        pageViewId ||
        contentViewId ||
        addToCartId ||
        checkoutInitiatedId ||
        addedPaymentInfoId ||
        purchaseId
      ) {
        const script = document.createElement("script");
        script.innerHTML = `!function(e,t,n,s,u,a){e.twq||(s=e.twq=function(){s.exe?s.exe.apply(s,arguments):s.queue.push(arguments);
      },s.version='1.1',s.queue=[],u=t.createElement(n),u.async=!0,u.src='/js/twitter-script.js',
      a=t.getElementsByTagName(n)[0],a.parentNode.insertBefore(u,a))}(window,document,'script');
      twq('config','oejn5');`;
        document.head.appendChild(script);
        handleTwitter(this);
        if (pageViewId || contentViewId) {
          //@ts-ignore
          TwitterTracking(twq, this, "ContentView");
          //@ts-ignore
          TwitterTracking(twq, this, "PageView");
        }
      }
    }
  }

  loadScriptSnap() {
    const snap = this.$store.state.setting.snap;
    if (snap?.platformId) {
      const listSnap = snap.platformId
        .split("\n")
        .filter((item: string) => item);
      //@ts-ignore
      if (snaptr) {
        for (let item of listSnap) {
          //@ts-ignore
          snaptr("init", `${item}`);
        }
        //@ts-ignore
        snaptr("track", "PAGE_VIEW");
        //@ts-ignore
        snaptr("track", "VIEW_CONTENT");
      }
    }
  }

  async onGetListCart() {
    try {
      const cart: any = onGetListCart();
      this.$store.commit("cart/setListCart", cart);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
}
</script>
